%global gem_name narray

# For compatibility with RHEL <= 6
%{!?ruby_vendorlibdir:	%global ruby_vendorlibdir	%(ruby -rrbconfig -W0 -e "puts Config::CONFIG['sitelibdir']")}
%{!?ruby_vendorarchdir:	%global ruby_vendorarchdir	%(ruby -rrbconfig -W0 -e "puts Config::CONFIG['sitearchdir']")}
%{!?gem_dir:		%global gem_dir			%(ruby -rubygems -e 'puts Gem::dir' 2>/dev/null)}
%{!?gem_instdir:	%global gem_instdir		%{gem_dir}/gems/%{gem_name}-%{version}}
%{!?gem_libdir:		%global gem_libdir		%{gem_instdir}/lib}
%{!?gem_cache:		%global gem_cache		%{gem_dir}/cache/%{gem_name}-%{version}.gem}
%{!?gem_spec:		%global gem_spec		%{gem_dir}/specifications/%{gem_name}-%{version}.gemspec}
%{!?gem_docdir:		%global gem_docdir		%{gem_dir}/doc/%{gem_name}-%{version}}
%{!?gem_extdir_mri:	%global gem_extdir_mri		%{ruby_vendorarchdir}}

Name:		rubygem-%{gem_name}
Version:	0.6.0.8
Release:	9%{?dist}
Summary:	N-dimensional Numerical Array class for Ruby
%{?el5:Group:	System Environment/Libraries}

License:	BSD and Ruby
URL:		http://%{gem_name}.rubyforge.org
Source0:	http://rubygems.org/downloads/%{gem_name}-%{version}.gem

%{?el5:BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)}
BuildRequires:	ruby-devel

%if 0%{?fedora} >= 19 || 0%{?rhel} >= 7
BuildRequires:	rubygems-devel

Requires:	ruby(release)
%else
BuildRequires:	rubygems%{!?el5:-devel}

%{?rhel:Requires:	ruby(abi)		=  1.8}
%{!?rhel:Requires:	ruby(abi)		=  1.9.1}
%endif
Requires:	rubygems

%if 0%{?fedora} && 0%{?fedora} <= 22
Obsoletes:	%{name}-common			<= %{version}-%{release}
%endif

Provides:	rubygem(%{gem_name})		=  %{version}
Provides:	rubygem(%{gem_name})%{?_isa}	=  %{version}

%description
NArray is a Numerical N-dimensional Array class.  Supported element types are
1/2/4-byte Integer, single/double-precision, Real/Complex and Ruby Object.
This extension library incorporates fast calculation and easy manipulation of
large numerical arrays into the Ruby language.  NArray has features similar to
NumPy, but NArray has vector and matrix sub-classes.


%package devel
Summary:	Development files and developer's docs for %{name}
%{?el5:Group:	Development/Libraries}

%if 0%{?fedora} || 0%{?rhel} >= 7
BuildArch:	noarch
Requires:	%{name}				=  %{version}-%{release}
%else
Requires:	%{name}%{?_isa}			=  %{version}-%{release}
%endif

%if 0%{?fedora} && 0%{?fedora} <= 22
Obsoletes:	%{name}-devel			<= %{version}-%{release}
Obsoletes:	%{name}-common-devel		<= %{version}-%{release}
Obsoletes:	%{name}-doc			<= %{version}-%{release}
%endif

%description devel
This package contains the development files and the developer's documentation
for %{name}.


%prep
rm -rf %{gem_name}-%{version}
gem unpack %{SOURCE0}
%setup -qDTn  %{gem_name}-%{version}
gem spec %{SOURCE0} -l %{!?el5:--ruby} > %{gem_name}.gemspec


%build
gem build %{gem_name}.gemspec

%if 0%{?fedora} >= 19 || 0%{?rhel} >= 7
%gem_install
%else
export CONFIGURE_ARGS="--with-cflags='%{optflags}'"
mkdir -p ./%{gem_dir}
gem install								\
	-V --local --install-dir ./%{gem_dir} --bindir ./%{_bindir}	\
	--force --backtrace %{gem_name}-%{version}.gem
%endif


%install
%{?el5:rm -rf %{buildroot}}
mkdir -p %{buildroot}%{gem_dir}						\
	%{buildroot}%{gem_extdir_mri}					\
	%{buildroot}%{ruby_vendorarchdir}
cp -a ./%{gem_dir}/* %{buildroot}%{gem_dir}
mv -f %{buildroot}%{gem_instdir}/%{gem_name}.so				\
	%{buildroot}%{gem_extdir_mri}

# On <= el6 there needs to be a symlink for %%{gem_name}_ext.rb
# in %%{ruby_vendorarchdir}.  Otherwise the so-plugin can't be loaded.
%if 0%{?rhel} && 0%{?rhel} <= 6
ln -fs	%{gem_instdir}/%{gem_name}_ext.rb				\
	%{buildroot}%{gem_extdir_mri}
%endif

# Clean-up
find %{buildroot}%{gem_instdir} -depth -type f -name '*.so' -print0 |	\
	xargs -0 rm -rf
find %{buildroot} -depth -type f -name '.*' -print0 |			\
	xargs -0 rm -rf
find %{buildroot} -depth -type f -name '*.o' -print0 |			\
	xargs -0 rm -rf
find %{buildroot} -depth -size 0 -type f -print0 |			\
	xargs -0 rm -rf
rm -rf	%{buildroot}%{gem_cache}					\
	%{buildroot}%{gem_instdir}/src					\
	%{buildroot}%{gem_instdir}/%{gem_name}.gemspec


%{?el5:%clean}
%{?el5:rm -rf %{buildroot}}


%files
%doc %{gem_instdir}/ChangeLog
%doc %{gem_instdir}/README.*
%dir %{gem_instdir}
%exclude %{gem_instdir}/MANIFEST
%exclude %{gem_instdir}/SPEC.*
%exclude %{gem_instdir}/*.h
%if 0%{?fedora} >= 19 || 0%{?rhel} >= 7
%{gem_extdir_mri}
%else
%{gem_extdir_mri}/%{gem_name}*
%endif
%{gem_instdir}/*.rb
%{gem_spec}

%files devel
%doc %{gem_docdir}
%doc %{gem_instdir}/MANIFEST
%doc %{gem_instdir}/SPEC.*
%{gem_instdir}/*.h


%changelog
* Fri Dec 13 2013 Björn Esser <bjoern.esser@gmail.com> - 0.6.0.8-9
- fixed the way ruby(abi) is required
- dropped the symlinks in %%{ruby_vendorarchdir}, except for <= el6
- fixed directory ownerships on <= el6
- use BuildRequires: rubygems-devel on el6, too

* Tue Dec 10 2013 Björn Esser <bjoern.esser@gmail.com> - 0.6.0.8-8
- fixed symlinks in %%{ruby_vendorarchdir}

* Tue Dec 10 2013 Björn Esser <bjoern.esser@gmail.com> - 0.6.0.8-7
- adapted Requires: ruby(abi) = 1.9.1 for Fedora 18, only

* Tue Dec 10 2013 Björn Esser <bjoern.esser@gmail.com> - 0.6.0.8-6
- several improvements for RHEL <= 6 and added needed bits for RHEL <= 5
- added needed Provides

* Mon Nov 25 2013 Björn Esser <bjoern.esser@gmail.com> - 0.6.0.8-5
- Fedora <= 18 && RHEL <= 6 need Requires: ruby(abi)

* Mon Nov 25 2013 Björn Esser <bjoern.esser@gmail.com> - 0.6.0.8-4
- added conditional for Requires: ruby(release) or ruby(abi) on older dists

* Mon Oct 28 2013 Björn Esser <bjoern.esser@gmail.com> - 0.6.0.8-3
- added symlink to %%{gem_name}_ext.rb in %%{ruby_vendorarchdir}

* Sun Sep 15 2013 Björn Esser <bjoern.esser@gmail.com> - 0.6.0.8-2
- obsoleted common, common-devel and doc pkg
- moved some development-related files from main to devel pkg
- removed some unneeded files, e.g. the copy of sources inside %%{gem_instdir}

* Sat Sep 07 2013 Björn Esser <bjoern.esser@gmail.com> - 0.6.0.8-1
- Initial rpm release (#1005463)
